postgresql-9.0 (9.0.23-10.pgdg+1) sid-pgdg; urgency=medium

  * Rebuild for sid-pgdg.
  * Changes applied by generate-pgdg-source:
    + Moving lib packages to component 9.0.
    + Enabling cassert.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Fri, 24 May 2024 21:44:19 +0200

postgresql-9.0 (9.0.23-10) unstable; urgency=medium

  * Fix doc install when postgresql-client-common is not present.
  * DH 13 and autoreconf at build time.
  * Fix config/c-compiler.m4 for new compiler warnings.

 -- Christoph Berg <myon@debian.org>  Fri, 24 May 2024 21:44:19 +0200

postgresql-9.0 (9.0.23-9) unstable; urgency=medium

  * Test-Depend on tzdata-legacy | tzdata (<< 2023c-8).

 -- Christoph Berg <myon@debian.org>  Thu, 10 Aug 2023 22:25:38 +0200

postgresql-9.0 (9.0.23-8) unstable; urgency=medium

  * Fix update-alternatives when doc package is installed stand-alone.

 -- Christoph Berg <myon@debian.org>  Mon, 27 Feb 2023 10:53:17 +0100

postgresql-9.0 (9.0.23-7) unstable; urgency=medium

  * R³: no.
  * run-testsuite: Test only this version.

 -- Christoph Berg <myon@debian.org>  Wed, 22 Dec 2021 16:37:44 +0100

postgresql-9.0 (9.0.23-6) unstable; urgency=medium

  * Use secure copyright file specification URI.
  * src/test/regress/results/xml.out: Catch less verbose error output on
    xenial.

 -- Christoph Berg <myon@debian.org>  Wed, 06 May 2020 09:42:29 +0200

postgresql-9.0 (9.0.23-5) unstable; urgency=medium

  * Disable plpython2 package.
  * Remove obsolete Conflicts/Replaces.
  * Add debian/gitlab-ci.yml.
  * debian/tests: Also run regression tests.
  * debian/copyright: Fix syntax and add pointer to perl licenses.

 -- Christoph Berg <myon@debian.org>  Wed, 09 Oct 2019 20:19:51 +0200

postgresql-9.0 (9.0.23-4) sid-pgdg; urgency=medium

  * Disable ssl; package supports OpenSSL 1.0 only which got removed
    from unstable.

 -- Christoph Berg <myon@debian.org>  Mon, 04 Mar 2019 09:29:05 +0100

postgresql-9.0 (9.0.23-3) sid-pgdg; urgency=medium

  * Remove empty conf.d directory on purge, even when postgresql-common
    was already removed. (Closes: #877264)
  * Drop support for tcl8.5.
  * Use dh_auto_configure to correctly seed the build architecture.
  * psql uses sensible-editor, depend on sensible-utils.
  * Add lintian overrides for plugins that link no external libraries.
  * configure: Hard-code paths to /bin/mkdir -p and /bin/tar.
  * Depend on locales | locales-all. Suggested by Elrond, thanks!
    (Closes: #916655)
  * Build-Depend on tcl-dev instead of on a specific version.

 -- Christoph Berg <myon@debian.org>  Sat, 02 Feb 2019 15:17:57 +0100

postgresql-9.0 (9.0.23-2) sid-pgdg; urgency=medium

  * Remove hardening-wrapper logic, it's being removed from sid.
  * debian/control: Add alternative dependency on libssl1.0-dev.
  * libpq-dev: Remove dependency on libssl-dev (and comerr-dev and
    libkrb5-dev) to unbreak co-installation with libssl1.0-dev.
  * Cherry-pick 52f6b2e5 from 9.2 to support newer IANA timezone databases.

 -- Christoph Berg <myon@debian.org>  Sat, 23 Sep 2017 20:14:17 +0200

postgresql-9.0 (9.0.23-1) unstable; urgency=medium

  * New upstream version.

    This is expected to be the last PostgreSQL release in the 9.0.X series.
    Users are encouraged to update to a newer release branch soon.

    + Fix contrib/pgcrypto to detect and report too-short crypt() salts
      (Josh Kupershmidt)

      Certain invalid salt arguments crashed the server or disclosed a few
      bytes of server memory.  We have not ruled out the viability of attacks
      that arrange for presence of confidential information in the disclosed
      bytes, but they seem unlikely.  (CVE-2015-5288)

  * Add docbook-xml to build-depends.
  * debian/rules: Remove broken "generate POT files for translators" code.
  * postgresql postrm: Don't clean {/etc,/var/lib,/var/log}/postgresql on
    purge.  (Closes: #793861)

 -- Christoph Berg <christoph.berg@credativ.de>  Tue, 06 Oct 2015 11:11:14 +0200

postgresql-9.0 (9.0.22-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream version.
    + Fix rare failure to invalidate relation cache init file

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 10 Jun 2015 13:55:38 +0200

postgresql-9.0 (9.0.21-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream version including the fsync fix.

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 03 Jun 2015 12:22:32 +0200

postgresql-9.0 (9.0.20-2.pgdg+1) sid-pgdg; urgency=medium

  * Fix fsync-at-startup code to not treat errors as fatal.
    (Abhijit Menon-Sen and Tom Lane, Closes: #786874)

 -- Christoph Berg <myon@debian.org>  Fri, 29 May 2015 21:52:25 +0200

postgresql-9.0 (9.0.20-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream version.

    + Avoid possible crash when client disconnects just before the
      authentication timeout expires (Benkocs Norbert Attila)

      If the timeout interrupt fired partway through the session shutdown
      sequence, SSL-related state would be freed twice, typically causing a
      crash and hence denial of service to other sessions.  Experimentation
      shows that an unauthenticated remote attacker could trigger the bug
      somewhat consistently, hence treat as security issue. (CVE-2015-3165)

    + Improve detection of system-call failures (Noah Misch)

      Our replacement implementation of snprintf() failed to check for errors
      reported by the underlying system library calls; the main case that
      might be missed is out-of-memory situations. In the worst case this
      might lead to information exposure, due to our code assuming that a
      buffer had been overwritten when it hadn't been. Also, there were a few
      places in which security-relevant calls of other system library
      functions did not check for failure.

      It remains possible that some calls of the *printf() family of functions
      are vulnerable to information disclosure if an out-of-memory error
      occurs at just the wrong time.  We judge the risk to not be large, but
      will continue analysis in this area. (CVE-2015-3166)

    + In contrib/pgcrypto, uniformly report decryption failures as Wrong key
      or corrupt data (Noah Misch)

      Previously, some cases of decryption with an incorrect key could report
      other error message texts.  It has been shown that such variance in
      error reports can aid attackers in recovering keys from other systems.
      While it's unknown whether pgcrypto's specific behaviors are likewise
      exploitable, it seems better to avoid the risk by using a
      one-size-fits-all message. (CVE-2015-3167)

  * Repository moved to git, update Vcs headers.

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 20 May 2015 13:38:56 +0200

postgresql-9.0 (9.0.19-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream release.
    + Fix buffer overruns in to_char() (CVE-2015-0241)
    + Fix buffer overruns in contrib/pgcrypto (CVE-2015-0243)
    + Fix possible loss of frontend/backend protocol synchronization after an
      error (CVE-2015-0244)
    + Fix information leak via constraint-violation error messages
      (CVE-2014-8161)
  * Add dependencies on libkrb5-dev next to krb5-multidev.

 -- Christoph Berg <myon@debian.org>  Wed, 04 Feb 2015 23:19:53 +0100

postgresql-9.0 (9.0.18-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream release.
    + Secure Unix-domain sockets of temporary postmasters started during make
      check (Noah Misch)

      Any local user able to access the socket file could connect as the
      server's bootstrap superuser, then proceed to execute arbitrary code as
      the operating-system user running the test, as we previously noted in
      CVE-2014-0067. This change defends against that risk by placing the
      server's socket in a temporary, mode 0700 subdirectory of /tmp.

  * Remove our pg_regress patches to support --host=/path.
  * Remove the tcl8.6 patch, went upstream.
  * New patch 90-make4.0 to fix 9.0 build with make 4.0.

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 23 Jul 2014 13:19:24 +0200

postgresql-9.0 (9.0.17-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream bugfix release.
  * Build with tcl8.6 where available (>= Jessie, >= trusty).
  * Compile with -fno-omit-frame-pointer on amd64 to facilitate hierarchical
    profile generation. (Closes: #730134)
  * Remove obsolete configure option --with-tkconfig.

 -- Christoph Berg <myon@debian.org>  Tue, 18 Mar 2014 23:36:40 +0100

postgresql-9.0 (9.0.16-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream security/bugfix release.

    + Shore up GRANT ... WITH ADMIN OPTION restrictions (Noah Misch)

      Granting a role without ADMIN OPTION is supposed to prevent the grantee
      from adding or removing members from the granted role, but this
      restriction was easily bypassed by doing SET ROLE first. The security
      impact is mostly that a role member can revoke the access of others,
      contrary to the wishes of his grantor. Unapproved role member additions
      are a lesser concern, since an uncooperative role member could provide
      most of his rights to others anyway by creating views or SECURITY
      DEFINER functions. (CVE-2014-0060)

    + Prevent privilege escalation via manual calls to PL validator functions
      (Andres Freund)

      The primary role of PL validator functions is to be called implicitly
      during CREATE FUNCTION, but they are also normal SQL functions that a
      user can call explicitly. Calling a validator on a function actually
      written in some other language was not checked for and could be
      exploited for privilege-escalation purposes. The fix involves adding a
      call to a privilege-checking function in each validator function.
      Non-core procedural languages will also need to make this change to
      their own validator functions, if any. (CVE-2014-0061)

    + Avoid multiple name lookups during table and index DDL (Robert Haas,
      Andres Freund)

      If the name lookups come to different conclusions due to concurrent
      activity, we might perform some parts of the DDL on a different table
      than other parts. At least in the case of CREATE INDEX, this can be used
      to cause the permissions checks to be performed against a different
      table than the index creation, allowing for a privilege escalation
      attack. (CVE-2014-0062)

    + Prevent buffer overrun with long datetime strings (Noah Misch)

      The MAXDATELEN constant was too small for the longest possible value of
      type interval, allowing a buffer overrun in interval_out(). Although the
      datetime input functions were more careful about avoiding buffer
      overrun, the limit was short enough to cause them to reject some valid
      inputs, such as input containing a very long timezone name. The ecpg
      library contained these vulnerabilities along with some of its own.
      (CVE-2014-0063)

    + Prevent buffer overrun due to integer overflow in size calculations
      (Noah Misch, Heikki Linnakangas)

      Several functions, mostly type input functions, calculated an allocation
      size without checking for overflow. If overflow did occur, a too-small
      buffer would be allocated and then written past. (CVE-2014-0064)

    + Prevent overruns of fixed-size buffers (Peter Eisentraut, Jozef Mlich)

      Use strlcpy() and related functions to provide a clear guarantee that
      fixed-size buffers are not overrun. Unlike the preceding items, it is
      unclear whether these cases really represent live issues, since in most
      cases there appear to be previous constraints on the size of the input
      string. Nonetheless it seems prudent to silence all Coverity warnings of
      this type. (CVE-2014-0065)

    + Avoid crashing if crypt() returns NULL (Honza Horak, Bruce Momjian)

      There are relatively few scenarios in which crypt() could return NULL,
      but contrib/chkpass would crash if it did. One practical case in which
      this could be an issue is if libc is configured to refuse to execute
      unapproved hashing algorithms (e.g., "FIPS mode"). (CVE-2014-0066)

    + Document risks of make check in the regression testing instructions
      (Noah Misch, Tom Lane)

      Since the temporary server started by make check uses "trust"
      authentication, another user on the same machine could connect to it as
      database superuser, and then potentially exploit the privileges of the
      operating-system user who started the tests. A future release will
      probably incorporate changes in the testing procedure to prevent this
      risk, but some public discussion is needed first. So for the moment,
      just warn people against using make check when there are untrusted users
      on the same machine. (CVE-2014-0067)

  * The upstream tarballs no longer contain a plain HISTORY file, but point to
    the html documentation. Note the location of these files in our
    changelog.gz file.

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 19 Feb 2014 12:02:15 +0100

postgresql-9.0 (9.0.15-1.pgdg+1) sid-pgdg; urgency=low

  * New upstream version.

    + Fix "VACUUM"'s tests to see whether it can update relfrozenxid
      (Andres Freund)

      In some cases "VACUUM" (either manual or autovacuum) could
      incorrectly advance a table's relfrozenxid value, allowing tuples
      to escape freezing, causing those rows to become invisible once
      2^31 transactions have elapsed. The probability of data loss is
      fairly low since multiple incorrect advancements would need to
      happen before actual loss occurs, but it's not zero. Users
      upgrading from releases 9.0.4 or 8.4.8 or earlier are not affected,
      but all later versions contain the bug.
      The issue can be ameliorated by, after upgrading, vacuuming all
      tables in all databases while having vacuum_freeze_table_age set to
      zero. This will fix any latent corruption but will not be able to
      fix all pre-existing data errors. However, an installation can be
      presumed safe after performing this vacuuming if it has executed
      fewer than 2^31 update transactions in its lifetime (check this
      with SELECT txid_current() < 2^31).

    + Fix initialization of "pg_clog" and "pg_subtrans" during hot
      standby startup (Andres Freund, Heikki Linnakangas)

      This bug can cause data loss on standby servers at the moment they
      start to accept hot-standby queries, by marking committed
      transactions as uncommitted. The likelihood of such corruption is
      small unless, at the time of standby startup, the primary server
      has executed many updating transactions since its last checkpoint.
      Symptoms include missing rows, rows that should have been deleted
      being still visible, and obsolete versions of updated rows being
      still visible alongside their newer versions.
      This bug was introduced in versions 9.3.0, 9.2.5, 9.1.10, and
      9.0.14. Standby servers that have only been running earlier
      releases are not at risk. It's recommended that standby servers
      that have ever run any of the buggy releases be re-cloned from the
      primary (e.g., with a new base backup) after upgrading.

 -- Christoph Berg <myon@debian.org>  Tue, 03 Dec 2013 09:01:03 +0100

postgresql-9.0 (9.0.14-1.pgdg+1) sid-pgdg; urgency=low

  * New upstream version.
  * Remove "#libpq-dev" from Build-Depends.
  * Remove remaining traces (comments, dead code) of the plpython3 package.

 -- Christoph Berg <myon@debian.org>  Tue, 08 Oct 2013 23:09:34 +0200

postgresql-9.0 (9.0.13-1.pgdg+1) sid-pgdg; urgency=high

  * New upstream version.
  * Included security fixes:

    + Fix insecure parsing of server command-line switches (Mitsumasa Kondo,
      Kyotaro Horiguchi)

      A connection request containing a database name that begins with - could
      be crafted to damage or destroy files within the server's data
      directory, even if the request is eventually rejected.  (CVE-2013-1899)

    + Reset OpenSSL randomness state in each postmaster child process
      (Marko Kreen)

      This avoids a scenario wherein random numbers generated by
      contrib/pgcrypto functions might be relatively easy for another database
      user to guess.  The risk is only significant when the postmaster is
      configured with ssl = on but most connections don't use SSL encryption.
      (CVE-2013-1900)

    + Make REPLICATION privilege checks test current user not authenticated
      user (Noah Misch)

      An unprivileged database user could exploit this mistake to call
      pg_start_backup() or pg_stop_backup(), thus possibly interfering with
      creation of routine backups. (CVE-2013-1901)

  * Included fixes that might need user action:

    + Fix GiST indexes to not use fuzzy geometric comparisons when it's not
      appropriate to do so (Alexander Korotkov)

      The core geometric types perform comparisons using fuzzy equality, but
      gist_box_same must do exact comparisons, else GiST indexes using it
      might become inconsistent.  After installing this update, users should
      REINDEX any GiST indexes on box, polygon, circle, or point columns,
      since all of these use gist_box_same.

    + Fix erroneous range-union and penalty logic in GiST indexes that use
      contrib/btree_gist for variable-width data types, that is text, bytea,
      bit, and numeric columns (Tom Lane)

      These errors could result in inconsistent indexes in which some keys
      that are present would not be found by searches, and also in useless
      index bloat.  Users are advised to REINDEX such indexes after installing
      this update.

    + Fix bugs in GiST page splitting code for multi-column indexes (Tom Lane)

      These errors could result in inconsistent indexes in which some keys
      that are present would not be found by searches, and also in indexes
      that are unnecessarily inefficient to search.  Users are advised to
      REINDEX multi-column GiST indexes after installing this update.

  * For a full list of changes, see the release notes in the documentation.

 -- Christoph Berg <myon@debian.org>  Tue, 02 Apr 2013 11:11:30 +0200

postgresql-9.0 (9.0.12-1.pgdg+1) sid-pgdg; urgency=medium

  * New upstream version.
    + Prevent execution of enum_recv from SQL
      The function was misdeclared, allowing a simple SQL command to crash the
      server.  In principle an attacker might be able to use it to examine the
      contents of server memory.  Our thanks to Sumit Soni (via Secunia SVCRP)
      for reporting this issue. (CVE-2013-0255)

 -- Christoph Berg <myon@debian.org>  Tue, 05 Feb 2013 10:11:43 +0100

postgresql-9.0 (9.0.11-2.pgdg+1) sid-pgdg; urgency=low

  * debian/tests: Moved autopkgtest integration here from postgresql-common.
  * Add missing docbook build dependency. (Closes: #697618)
  * debian/rules: Remove the temporary patches from pg_regress, and teach
    pg_regress to support unix socket dirs in --host.

 -- Christoph Berg <myon@debian.org>  Tue, 29 Jan 2013 11:05:07 +0100

postgresql-9.0 (9.0.11-1.pgdg+1) sid-pgdg; urgency=low

  * New upstream bug fix release. See
    /usr/share/doc/postgresql-9.0/changelog.gz for details.

 -- Christoph Berg <myon@debian.org>  Tue, 04 Dec 2012 17:00:54 +0100

postgresql-9.0 (9.0.10-1.pgdgl+1) sid-pgdg; urgency=low

  * New upstream bug fix release.
     * Fix planner's assignment of executor parameters, and fix executor's
       rescan logic for CTE plan nodes (Tom Lane)
       These errors could result in wrong answers from queries that scan
       the same WITH subquery multiple times.
     * Improve page-splitting decisions in GiST indexes (Alexander
       Korotkov, Robert Haas, Tom Lane)
       Multi-column GiST indexes might suffer unexpected bloat due to this
       error.
     * Fix cascading privilege revoke to stop if privileges are still held
       (Tom Lane)
       If we revoke a grant option from some role "X", but "X" still holds
       that option via a grant from someone else, we should not
       recursively revoke the corresponding privilege from role(s) "Y"
       that "X" had granted it to.
     * Improve error messages for Hot Standby misconfiguration errors
       (Gurjeet Singh)
     * Fix handling of SIGFPE when PL/Perl is in use (Andres Freund)
       Perl resets the process's SIGFPE handler to SIG_IGN, which could
       result in crashes later on. Restore the normal Postgres signal
       handler after initializing PL/Perl.
     * Prevent PL/Perl from crashing if a recursive PL/Perl function is
       redefined while being executed (Tom Lane)
     * Work around possible misoptimization in PL/Perl (Tom Lane)
       Some Linux distributions contain an incorrect version of
       "pthread.h" that results in incorrect compiled code in PL/Perl,
       leading to crashes if a PL/Perl function calls another one that
       throws an error.
     * Fix pg_upgrade's handling of line endings on Windows (Andrew
       Dunstan)
       Previously, pg_upgrade might add or remove carriage returns in
       places such as function bodies.
     * On Windows, make pg_upgrade use backslash path separators in the
       scripts it emits (Andrew Dunstan)
     * Update time zone data files to tzdata release 2012f for DST law
       changes in Fiji

 -- Christoph Berg <myon@debian.org>  Sun, 30 Sep 2012 12:58:28 +0200

postgresql-9.0 (9.0.9-1~pgapt+1) sid-pgapt; urgency=low

  * New upstream bug fix release.
     * Prevent access to external files/URLs via XML entity references
       (Noah Misch, Tom Lane)
       xml_parse() would attempt to fetch external files or URLs as needed
       to resolve DTD and entity references in an XML value, thus allowing
       unprivileged database users to attempt to fetch data with the
       privileges of the database server. While the external data wouldn't
       get returned directly to the user, portions of it could be exposed
       in error messages if the data didn't parse as valid XML; and in any
       case the mere ability to check existence of a file might be useful
       to an attacker. (CVE-2012-3489)
     * Prevent access to external files/URLs via "contrib/xml2"'s
       xslt_process() (Peter Eisentraut)
       libxslt offers the ability to read and write both files and URLs
       through stylesheet commands, thus allowing unprivileged database
       users to both read and write data with the privileges of the
       database server. Disable that through proper use of libxslt's
       security options. (CVE-2012-3488)
       Also, remove xslt_process()'s ability to fetch documents and
       stylesheets from external files/URLs. While this was a documented
       "feature", it was long regarded as a bad idea. The fix for
       CVE-2012-3489 broke that capability, and rather than expend effort
       on trying to fix it, we're just going to summarily remove it.
     * Prevent too-early recycling of btree index pages (Noah Misch)
       When we allowed read-only transactions to skip assigning XIDs, we
       introduced the possibility that a deleted btree page could be
       recycled while a read-only transaction was still in flight to it.
       This would result in incorrect index search results. The
       probability of such an error occurring in the field seems very low
       because of the timing requirements, but nonetheless it should be
       fixed.
     * Fix crash-safety bug with newly-created-or-reset sequences (Tom
       Lane)
       If "ALTER SEQUENCE" was executed on a freshly created or reset
       sequence, and then precisely one nextval() call was made on it, and
       then the server crashed, WAL replay would restore the sequence to a
       state in which it appeared that no nextval() had been done, thus
       allowing the first sequence value to be returned again by the next
       nextval() call. In particular this could manifest for serial
       columns, since creation of a serial column's sequence includes an
       "ALTER SEQUENCE OWNED BY" step.
     * Fix txid_current() to report the correct epoch when not in hot
       standby (Heikki Linnakangas)
       This fixes a regression introduced in the previous minor release.
     * Fix bug in startup of Hot Standby when a master transaction has
       many subtransactions (Andres Freund)
       This mistake led to failures reported as "out-of-order XID
       insertion in KnownAssignedXids".
     * Ensure the "backup_label" file is fsync'd after pg_start_backup()
       (Dave Kerr)
     * Fix timeout handling in walsender processes (Tom Lane)
       WAL sender background processes neglected to establish a SIGALRM
       handler, meaning they would wait forever in some corner cases where
       a timeout ought to happen.
     * Back-patch 9.1 improvement to compress the fsync request queue
       (Robert Haas)
       This improves performance during checkpoints. The 9.1 change has
       now seen enough field testing to seem safe to back-patch.
     * Fix LISTEN/NOTIFY to cope better with I/O problems, such as out of
       disk space (Tom Lane)
       After a write failure, all subsequent attempts to send more NOTIFY
       messages would fail with messages like "Could not read from file
       "pg_notify/nnnn" at offset nnnnn: Success".
     * Only allow autovacuum to be auto-canceled by a directly blocked
       process (Tom Lane)
       The original coding could allow inconsistent behavior in some
       cases; in particular, an autovacuum could get canceled after less
       than deadlock_timeout grace period.
     * Improve logging of autovacuum cancels (Robert Haas)
     * Fix log collector so that log_truncate_on_rotation works during the
       very first log rotation after server start (Tom Lane)
     * Fix WITH attached to a nested set operation
       (UNION/INTERSECT/EXCEPT) (Tom Lane)
     * Ensure that a whole-row reference to a subquery doesn't include any
       extra GROUP BY or ORDER BY columns (Tom Lane)
     * Disallow copying whole-row references in CHECK constraints and
       index definitions during "CREATE TABLE" (Tom Lane)
       This situation can arise in "CREATE TABLE" with LIKE or INHERITS.
       The copied whole-row variable was incorrectly labeled with the row
       type of the original table not the new one. Rejecting the case
       seems reasonable for LIKE, since the row types might well diverge
       later. For INHERITS we should ideally allow it, with an implicit
       coercion to the parent table's row type; but that will require more
       work than seems safe to back-patch.
     * Fix memory leak in ARRAY(SELECT ...) subqueries (Heikki
       Linnakangas, Tom Lane)
     * Fix extraction of common prefixes from regular expressions (Tom
       Lane)
       The code could get confused by quantified parenthesized
       subexpressions, such as ^(foo)?bar. This would lead to incorrect
       index optimization of searches for such patterns.
     * Fix bugs with parsing signed "hh":"mm" and "hh":"mm":"ss" fields in
       interval constants (Amit Kapila, Tom Lane)
     * Use Postgres' encoding conversion functions, not Python's, when
       converting a Python Unicode string to the server encoding in
       PL/Python (Jan Urbanski)
       This avoids some corner-case problems, notably that Python doesn't
       support all the encodings Postgres does. A notable functional
       change is that if the server encoding is SQL_ASCII, you will get
       the UTF-8 representation of the string; formerly, any non-ASCII
       characters in the string would result in an error.
     * Fix mapping of PostgreSQL encodings to Python encodings in
       PL/Python (Jan Urbanski)
     * Report errors properly in "contrib/xml2"'s xslt_process() (Tom
       Lane)
     * Update time zone data files to tzdata release 2012e for DST law
       changes in Morocco and Tokelau

 -- Christoph Berg <myon@debian.org>  Sat, 18 Aug 2012 22:35:55 +0200

postgresql-9.0 (9.0.8-1pgapt1) sid-pgapt; urgency=low

  * Merge from postgresql-9.1/trunk:
  * debian/copyright: Fix syntax for copyright format 1.0.
  * Add debian/source/options: Ignore test suite .sql files, to fix building
    twice in a row.
  * Port debian/rules from 9.1, dropping cdbs.
  * Disable plpython3 build for now, it is broken.
  * Re-add lib* packages.
  * Move lib* packages to component "9.0" so they don't conflict with newer
    versions in "main".
  * New upstream bug fix release.

    - Fix incorrect password transformation in contrib/pgcrypto's DES crypt()
      function (Solar Designer)

      If a password string contained the byte value 0x80, the remainder of the
      password was ignored, causing the password to be much weaker than it
      appeared. With this fix, the rest of the string is properly included in
      the DES hash. Any stored password values that are affected by this bug
      will thus no longer match, so the stored values may need to be updated.
      (CVE-2012-2143)

    - Ignore SECURITY DEFINER and SET attributes for a procedural language's
      call handler (Tom Lane)

      Applying such attributes to a call handler could crash the server.
      (CVE-2012-2655)

    - Allow numeric timezone offsets in timestamp input to be up to 16 hours
      away from UTC (Tom Lane)

      Some historical time zones have offsets larger than 15 hours, the
      previous limit. This could result in dumped data values being rejected
      during reload.

    - Fix timestamp conversion to cope when the given time is exactly the last
      DST transition time for the current timezone (Tom Lane)

      This oversight has been there a long time, but was not noticed
      previously because most DST-using zones are presumed to have an
      indefinite sequence of future DST transitions.

    - Fix text to name and char to name casts to perform string truncation
      correctly in multibyte encodings (Karl Schnaitter)

    - Fix memory copying bug in to_tsquery() (Heikki Linnakangas)

    - Ensure txid_current() reports the correct epoch when executed in hot
      standby (Simon Riggs)

    - Fix planner's handling of outer PlaceHolderVars within subqueries (Tom
      Lane)

      This bug concerns sub-SELECTs that reference variables coming from the
      nullable side of an outer join of the surrounding query. In 9.1, queries
      affected by this bug would fail with "ERROR: Upper-level PlaceHolderVar
      found where not expected". But in 9.0 and 8.4, you'd silently get
      possibly-wrong answers, since the value transmitted into the subquery
      wouldn't go to null when it should.

    - Fix slow session startup when pg_attribute is very large (Tom Lane)

      If pg_attribute exceeds one-fourth of shared_buffers, cache rebuilding
      code that is sometimes needed during session start would trigger the
      synchronized-scan logic, causing it to take many times longer than
      normal. The problem was particularly acute if many new sessions were
      starting at once.

    - Ensure sequential scans check for query cancel reasonably often (Merlin
      Moncure)

      A scan encountering many consecutive pages that contain no live tuples
      would not respond to interrupts meanwhile.

    - Ensure the Windows implementation of PGSemaphoreLock() clears
      ImmediateInterruptOK before returning (Tom Lane)

      This oversight meant that a query-cancel interrupt received later in the
      same query could be accepted at an unsafe time, with unpredictable but
      not good consequences.

    - Show whole-row variables safely when printing views or rules (Abbas
      Butt, Tom Lane)

      Corner cases involving ambiguous names (that is, the name could be
      either a table or column name of the query) were printed in an ambiguous
      way, risking that the view or rule would be interpreted differently
      after dump and reload. Avoid the ambiguous case by attaching a no-op
      cast.

    - Fix COPY FROM to properly handle null marker strings that correspond to
      invalid encoding (Tom Lane)

      A null marker string such as E'\\0' should work, and did work in the
      past, but the case got broken in 8.4.

    - Ensure autovacuum worker processes perform stack depth checking properly
      (Heikki Linnakangas)

      Previously, infinite recursion in a function invoked by auto-ANALYZE
      could crash worker processes.

    - Fix logging collector to not lose log coherency under high load (Andrew
      Dunstan)

      The collector previously could fail to reassemble large messages if it
      got too busy.

    - Fix logging collector to ensure it will restart file rotation after
      receiving SIGHUP (Tom Lane)

    - Fix WAL replay logic for GIN indexes to not fail if the index was
      subsequently dropped (Tom Lane)

    - Fix memory leak in PL/pgSQL's RETURN NEXT command (Joe Conway)

    - Fix PL/pgSQL's GET DIAGNOSTICS command when the target is the function's
      first variable (Tom Lane)

    - Fix potential access off the end of memory in psql's expanded display
      (\x) mode (Peter Eisentraut)

    - Fix several performance problems in pg_dump when the database contains
      many objects (Jeff Janes, Tom Lane)

      pg_dump could get very slow if the database contained many schemas, or
      if many objects are in dependency loops, or if there are many owned
      sequences.

    - Fix pg_upgrade for the case that a database stored in a non-default
      tablespace contains a table in the cluster's default tablespace (Bruce
      Momjian)

    - In ecpg, fix rare memory leaks and possible overwrite of one byte after
      the sqlca_t structure (Peter Eisentraut)

    - Fix contrib/dblink's dblink_exec() to not leak temporary database
      connections upon error (Tom Lane)

    - Fix contrib/dblink to report the correct connection name in error
      messages (Kyotaro Horiguchi)

    - Fix contrib/vacuumlo to use multiple transactions when dropping many
      large objects (Tim Lewis, Robert Haas, Tom Lane)

      This change avoids exceeding max_locks_per_transaction when many objects
      need to be dropped. The behavior can be adjusted with the new -l (limit)
      option.

    - Update time zone data files to tzdata release 2012c for DST law changes
      in Antarctica, Armenia, Chile, Cuba, Falkland Islands, Gaza, Haiti,
      Hebron, Morocco, Syria, and Tokelau Islands; also historical corrections
      for Canada.

 -- Christoph Berg <myon@debian.org>  Thu, 07 Jun 2012 17:54:57 +0200

postgresql-9.0 (9.0.7-1) unstable; urgency=low

  * New upstream bug fix release.
    - Require execute permission on the trigger function for CREATE TRIGGER
      This missing check could allow another user to execute a trigger function
      with forged input data, by installing it on a table he owns. This is only
      of significance for trigger functions marked SECURITY DEFINER, since
      otherwise trigger functions run as the table owner anyway.
      (CVE-2012-0866)
    - Remove arbitrary limitation on length of common name in SSL certificates
      Both libpq and the server truncated the common name extracted from an SSL
      certificate at 32 bytes. Normally this would cause nothing worse than an
      unexpected verification failure, but there are some rather-implausible
      scenarios in which it might allow one certificate holder to impersonate
      another. The victim would have to have a common name exactly 32 bytes
      long, and the attacker would have to persuade a trusted CA to issue a
      certificate in which the common name has that string as a prefix.
      Impersonating a server would also require some additional exploit to
      redirect client connections. (CVE-2012-0867)
    - Convert newlines to spaces in names written in pg_dump comments
      pg_dump was incautious about sanitizing object names that are emitted
      within SQL comments in its output script. A name containing a newline
      would at least render the script syntactically incorrect. Maliciously
      crafted object names could present a SQL injection risk when the script
      is reloaded. (CVE-2012-0868)
    - Fix btree index corruption from insertions concurrent with vacuuming
      An index page split caused by an insertion could sometimes cause a
      concurrently-running VACUUM to miss removing index entries that it should
      remove. After the corresponding table rows are removed, the dangling
      index entries would cause errors (such as "could not read block N in file
      ...") or worse, silently wrong query results after unrelated rows are
      re-inserted at the now-free table locations. This bug has been present
      since release 8.2, but occurs so infrequently that it was not diagnosed
      until now. If you have reason to suspect that it has happened in your
      database, reindexing the affected index will fix things.
    - Fix transient zeroing of shared buffers during WAL replay
      The replay logic would sometimes zero and refill a shared buffer, so that
      the contents were transiently invalid. In hot standby mode this can
      result in a query that's executing in parallel seeing garbage data.
      Various symptoms could result from that, but the most common one seems to
      be "invalid memory alloc request size".
    - Fix postmaster to attempt restart after a hot-standby crash
      A logic error caused the postmaster to terminate, rather than attempt to
      restart the cluster, if any backend process crashed while operating in
      hot standby mode.
    - Fix CLUSTER/VACUUM FULL handling of toast values owned by recently-updated rows
      This oversight could lead to "duplicate key value violates unique
      constraint" errors being reported against the toast table's index during
      one of these commands.
    - Update per-column permissions, not only per-table permissions, when
      changing table owner
      Failure to do this meant that any previously granted column permissions
      were still shown as having been granted by the old owner. This meant that
      neither the new owner nor a superuser could revoke the
      now-untraceable-to-table-owner permissions.
    - Support foreign data wrappers and foreign servers in REASSIGN OWNED
      This command failed with "unexpected classid" errors if it needed to
      change the ownership of any such objects.
    - Allow non-existent values for some settings in ALTER USER/DATABASE SET
      Allow default_text_search_config, default_tablespace, and
      temp_tablespaces to be set to names that are not known. This is because
      they might be known in another database where the setting is intended to
      be used, or for the tablespace cases because the tablespace might not be
      created yet. The same issue was previously recognized for search_path,
      and these settings now act like that one.
    - Avoid crashing when we have problems deleting table files post-commit
      Dropping a table should lead to deleting the underlying disk files only
      after the transaction commits. In event of failure then (for instance,
      because of wrong file permissions) the code is supposed to just emit a
      warning message and go on, since it's too late to abort the transaction.
      This logic got broken as of release 8.4, causing such situations to
      result in a PANIC and an unrestartable database.
    - Recover from errors occurring during WAL replay of DROP TABLESPACE
      Replay will attempt to remove the tablespace's directories, but there are
      various reasons why this might fail (for example, incorrect ownership or
      permissions on those directories). Formerly the replay code would panic,
      rendering the database unrestartable without manual intervention. It
      seems better to log the problem and continue, since the only consequence
      of failure to remove the directories is some wasted disk space.
    - Fix race condition in logging AccessExclusiveLocks for hot standby
      Sometimes a lock would be logged as being held by "transaction zero".
      This is at least known to produce assertion failures on slave servers,
      and might be the cause of more serious problems.
    - Track the OID counter correctly during WAL replay, even when it wraps
      around
      Previously the OID counter would remain stuck at a high value until the
      system exited replay mode. The practical consequences of that are usually
      nil, but there are scenarios wherein a standby server that's been
      promoted to master might take a long time to advance the OID counter to a
      reasonable value once values are needed.
    - Prevent emitting misleading "consistent recovery state reached" log
      message at the beginning of crash recovery
    - Fix initial value of pg_stat_replication.replay_location
      Previously, the value shown would be wrong until at least one WAL record
      had been replayed.
    - Fix regular expression back-references with * attached
      Rather than enforcing an exact string match, the code would effectively
      accept any string that satisfies the pattern sub-expression referenced by
      the back-reference symbol.
      A similar problem still afflicts back-references that are embedded in a
      larger quantified expression, rather than being the immediate subject of
      the quantifier. This will be addressed in a future PostgreSQL release.
    - Fix recently-introduced memory leak in processing of inet/cidr values
      A patch in the December 2011 releases of PostgreSQL caused memory leakage
      in these operations, which could be significant in scenarios such as
      building a btree index on such a column.
    - Fix dangling pointer after CREATE TABLE AS/SELECT INTO in a SQL-language
      function
      In most cases this only led to an assertion failure in assert-enabled
      builds, but worse consequences seem possible.
    - Avoid double close of file handle in syslogger on Windows
      Ordinarily this error was invisible, but it would cause an exception when
      running on a debug version of Windows.
    - Fix I/O-conversion-related memory leaks in plpgsql
      Certain operations would leak memory until the end of the current
      function.
    - Improve pg_dump's handling of inherited table columns
      pg_dump mishandled situations where a child column has a different
      default expression than its parent column. If the default is textually
      identical to the parent's default, but not actually the same (for
      instance, because of schema search path differences) it would not be
      recognized as different, so that after dump and restore the child would
      be allowed to inherit the parent's default. Child columns that are NOT
      NULL where their parent is not could also be restored subtly incorrectly.
    - Fix pg_restore's direct-to-database mode for INSERT-style table data
      Direct-to-database restores from archive files made with --inserts or
      --column-inserts options fail when using pg_restore from a release dated
      September or December 2011, as a result of an oversight in a fix for
      another problem. The archive file itself is not at fault, and text-mode
      output is okay.
    - Allow pg_upgrade to process tables containing regclass columns
      Since pg_upgrade now takes care to preserve pg_class OIDs, there was no
      longer any reason for this restriction.
    - Make libpq ignore ENOTDIR errors when looking for an SSL client
      certificate file
      This allows SSL connections to be established, though without a
      certificate, even when the user's home directory is set to something like
      /dev/null.
    - Fix some more field alignment issues in ecpg's SQLDA area
    - Allow AT option in ecpg DEALLOCATE statements
      The infrastructure to support this has been there for awhile, but through
      an oversight there was still an error check rejecting the case.
    - Do not use the variable name when defining a varchar structure in ecpg
    - Fix contrib/auto_explain's JSON output mode to produce valid JSON
      The output used brackets at the top level, when it should have used braces.
    - Fix error in contrib/intarray's int[] & int[] operator
      If the smallest integer the two input arrays have in common is 1, and
      there are smaller values in either array, then 1 would be incorrectly
      omitted from the result.
    - Fix error detection in contrib/pgcrypto's encrypt_iv() and decrypt_iv()
      These functions failed to report certain types of invalid-input errors,
      and would instead return random garbage values for incorrect input.
    - Fix one-byte buffer overrun in contrib/test_parser
      The code would try to read one more byte than it should, which would
      crash in corner cases. Since contrib/test_parser is only example code,
      this is not a security issue in itself, but bad example code is still
      bad.
    - Use __sync_lock_test_and_set() for spinlocks on ARM, if available
      This function replaces our previous use of the SWPB instruction, which is
      deprecated and not available on ARMv6 and later. Reports suggest that the
      old code doesn't fail in an obvious way on recent ARM boards, but simply
      doesn't interlock concurrent accesses, leading to bizarre failures in
      multiprocess operation.
    - Use -fexcess-precision=standard option when building with gcc versions
      that accept it
      This prevents assorted scenarios wherein recent versions of gcc will
      produce creative results.
    - Allow use of threaded Python on FreeBSD
      Our configure script previously believed that this combination wouldn't
      work; but FreeBSD fixed the problem, so remove that error check.
  * Set myself as maintainer.

  * Changes merged from 9.1 branch:
  * debian/control: Add missing docbook-dsssl build dependency to fix
    generation of documentation. (See: #654330)
  * debian/control: Use openjade instead of the ancient jade for building the
    documentation.
  * debian/control: Re-add bison and flex build dependencies, so that the
    generated and shipped Makefile.global gets non-empty BISON and FLEX
    values. (See: #647135)
  * Add docbook-xsl, opensp and xsltproc build dependencies.
  * debian/watch: Use ftp for checking, thanks Peter Eisentraut.
    (See: #656129)
  * debian/control: Bump Standards-Version to 3.9.3. No changes necessary.
  * debian/control, debian/rules: Support and prefer dpkg-buildflags when
    building with dpkg-dev >= 1.16.1~. Fall back to hardening-wrapper
    otherwise, to keep supporting backports.
  * debian/rules: Build with "-z now" for some extra hardening. We can't use
    the full "hardening=+all", as PIE causes build failures.

 -- Christoph Berg <myon@debian.org>  Sat, 03 Mar 2012 16:36:26 +0100

postgresql-9.0 (9.0.6-1) unstable; urgency=low

  * New upstream bug fix release.
    - Fix bugs in information_schema.referential_constraints view.
      This view was being insufficiently careful about matching the
      foreign-key constraint to the depended-on primary or unique key
      constraint. That could result in failure to show a foreign key
      constraint at all, or showing it multiple times, or claiming that
      it depends on a different constraint than the one it really does.
      Since the view definition is installed by initdb, merely upgrading
      will not fix the problem. If you need to fix this in an existing
      installation, you can (as a superuser) drop the information_schema
      schema then re-create it by sourcing
      "SHAREDIR/information_schema.sql". (Run pg_config --sharedir if
      you're uncertain where "SHAREDIR" is.) This must be repeated in
      each database to be fixed.
    - Fix possible crash during "UPDATE" or "DELETE" that joins to the
      output of a scalar-returning function. A crash could only occur if the
      target row had been concurrently updated, so this problem surfaced only
      intermittently.
    - Fix incorrect replay of WAL records for GIN index updates.
      This could result in transiently failing to find index entries
      after a crash, or on a hot-standby server. The problem would be
      repaired by the next "VACUUM" of the index, however.
    - Fix TOAST-related data corruption during CREATE TABLE dest AS
      SELECT - FROM src or INSERT INTO dest SELECT * FROM src.
      If a table has been modified by "ALTER TABLE ADD COLUMN", attempts
      to copy its data verbatim to another table could produce corrupt
      results in certain corner cases. The problem can only manifest in
      this precise form in 8.4 and later, but we patched earlier versions
      as well in case there are other code paths that could trigger the
      same bug.
    - Fix possible failures during hot standby startup.
    - Start hot standby faster when initial snapshot is incomplete.
    - Fix race condition during toast table access from stale syscache
      entries. The typical symptom was transient errors like "missing chunk
      number 0 for toast value NNNNN in pg_toast_2619", where the cited toast
      table would always belong to a system catalog.
    - Track dependencies of functions on items used in parameter default
      expressions. Previously, a referenced object could be dropped without
      having dropped or modified the function, leading to misbehavior when the
      function was used. Note that merely installing this update will not fix
      the missing dependency entries; to do that, you'd need to "CREATE OR
      REPLACE" each such function afterwards. If you have functions whose
      defaults depend on non-built-in objects, doing so is recommended.
    - Allow inlining of set-returning SQL functions with multiple OUT
      parameters.
    - Don't trust deferred-unique indexes for join removal.  A deferred
      uniqueness constraint might not hold intra-transaction, so assuming that
      it does could give incorrect query results.
    - Make DatumGetInetP() unpack inet datums that have a 1-byte header,
      and add a new macro, DatumGetInetPP(), that does not.
      This change affects no core code, but might prevent crashes in
      add-on code that expects DatumGetInetP() to produce an unpacked
      datum as per usual convention.
    - Improve locale support in money type's input and output. Aside from not
      supporting all standard lc_monetary formatting options, the input and
      output functions were inconsistent, meaning there were locales in which
      dumped money values could not be re-read.
    - Don't let transform_null_equals affect CASE foo WHEN NULL ...
      constructs.
    - Change foreign-key trigger creation order to better support
      self-referential foreign keys.
      For a cascading foreign key that references its own table, a row
      update will fire both the ON UPDATE trigger and the CHECK trigger
      as one event. The ON UPDATE trigger must execute first, else the
      CHECK will check a non-final state of the row and possibly throw an
      inappropriate error. However, the firing order of these triggers is
      determined by their names, which generally sort in creation order
      since the triggers have auto-generated names following the
      convention "RI_ConstraintTrigger_NNNN". A proper fix would require
      modifying that convention, which we will do in 9.2, but it seems
      risky to change it in existing releases. So this patch just changes
      the creation order of the triggers. Users encountering this type of
      error should drop and re-create the foreign key constraint to get
      its triggers into the right order.
    - Avoid floating-point underflow while tracking buffer allocation
      rate.
    - Fix incorrect field alignment in ecpg's SQLDA area.
    - Preserve blank lines within commands in psql's command history.
      The former behavior could cause problems if an empty line was
      removed from within a string literal, for example.
    - Fix pg_dump to dump user-defined casts between auto-generated
      types, such as table rowtypes.
    - Assorted fixes for pg_upgrade. Handle exclusion constraints correctly,
      don't complain about mismatched toast table names in 8.4 databases.
    - Use the preferred version of xsubpp to build PL/Perl, not
      necessarily the operating system's main copy.
    - Fix incorrect coding in "contrib/dict_int" and "contrib/dict_xsyn".
    - Fix assorted errors in "contrib/unaccent"'s configuration file
      parsing.
    - Honor query cancel interrupts promptly in pgstatindex().
    - Ensure VPATH builds properly install all server header files.
    - Shorten file names reported in verbose error messages.
      Regular builds have always reported just the name of the C file
      containing the error message call, but VPATH builds formerly
      reported an absolute path name.

 -- Martin Pitt <mpitt@debian.org>  Fri, 02 Dec 2011 14:39:25 +0100

postgresql-9.0 (9.0.5-1) unstable; urgency=low

  * New upstream bug fix release:
    - Fix catalog cache invalidation after a "VACUUM FULL" or "CLUSTER"
      on a system catalog. In some cases the relocation of a system catalog
      row to another place would not be recognized by concurrent server
      processes, allowing catalog corruption to occur if they then tried to
      update that row. The worst-case outcome could be as bad as complete loss
      of a table.
    - Fix incorrect order of operations during sinval reset processing,
      and ensure that TOAST OIDs are preserved in system catalogs.
      These mistakes could lead to transient failures after a "VACUUM
      FULL" or "CLUSTER" on a system catalog.
    - Fix bugs in indexing of in-doubt HOT-updated tuples.
      These bugs could result in index corruption after reindexing a
      system catalog. They are not believed to affect user indexes.
    - Fix multiple bugs in GiST index page split processing.
    - Fix possible buffer overrun in tsvector_concat().
    - Fix crash in xml_recv when processing a "standalone" parameter.
    - Make pg_options_to_table return NULL for an option with no value.
      Previously such cases would result in a server crash.
    - Avoid possibly accessing off the end of memory in "ANALYZE" and in
      SJIS-2004 encoding conversion.
      This fixes some very-low-probability server crash scenarios.
    - Protect pg_stat_reset_shared() against NULL input.
    - Fix possible failure when a recovery conflict deadlock is detected
      within a sub-transaction.
    - Avoid spurious conflicts while recycling btree index pages during
      hot standby.
    - Shut down WAL receiver if it's still running at end of recovery.
      The postmaster formerly panicked in this situation, but it's
      actually a legitimate case.
    - Fix race condition in relcache init file invalidation.
      There was a window wherein a new backend process could read a stale
      init file but miss the inval messages that would tell it the data
      is stale. The result would be bizarre failures in catalog accesses,
      typically "could not read block 0 in file ..." later during
      startup.
    - Fix memory leak at end of a GiST index scan.
    - Fix memory leak when encoding conversion has to be done on incoming
      command strings and "LISTEN" is active.
    - Fix incorrect memory accounting (leading to possible memory bloat)
      in tuplestores supporting holdable cursors and plpgsql's RETURN
      NEXT command.
    - Fix trigger WHEN conditions when both BEFORE and AFTER triggers
      exist.  Evaluation of WHEN conditions for AFTER ROW UPDATE triggers
      could crash if there had been a BEFORE ROW trigger fired for the same
      update.
    - Fix performance problem when constructing a large, lossy bitmap.
    - Fix join selectivity estimation for unique columns.
    - Fix nested PlaceHolderVar expressions that appear only in
      sub-select target lists. This mistake could result in outputs of an
      outer join incorrectly appearing as NULL.
    - Allow the planner to assume that empty parent tables really are
      empty.  Normally an empty table is assumed to have a certain minimum
      size for planning purposes; but this heuristic seems to do more harm
      than good for the parent table of an inheritance hierarchy, which
      often is permanently empty.
    - Allow nested EXISTS queries to be optimized properly.
    - Fix array- and path-creating functions to ensure padding bytes are
      zeroes. This avoids some situations where the planner will think that
      semantically-equal constants are not equal, resulting in poor
      optimization.
    - Fix "EXPLAIN" to handle gating Result nodes within inner-indexscan
      subplans.  The usual symptom of this oversight was "bogus varno" errors.
    - Fix btree preprocessing of "indexedcol" IS NULL conditions.
      Such a condition is unsatisfiable if combined with any other type
      of btree-indexable condition on the same index column. The case was
      handled incorrectly in 9.0.0 and later, leading to query output
      where there should be none.
    - Work around gcc 4.6.0 bug that breaks WAL replay.
      This could lead to loss of committed transactions after a server
      crash.
    - Fix dump bug for VALUES in a view.
    - Disallow SELECT FOR UPDATE/SHARE on sequences.
      This operation doesn't work as expected and can lead to failures.
    - Fix "VACUUM" so that it always updates pg_class.reltuples/relpages.
      This fixes some scenarios where autovacuum could make increasingly
      poor decisions about when to vacuum tables.
    - Defend against integer overflow when computing size of a hash table.
    - Fix cases where "CLUSTER" might attempt to access already-removed
      TOAST data.
    - Fix premature timeout failures during initial authentication
      transaction.
    - Fix portability bugs in use of credentials control messages for
      "peer" authentication. (see #627596, already fixed in Debian before)
    - Fix SSPI login when multiple roundtrips are required. The typical
      symptom of this problem was "The function requested is not supported"
      errors during SSPI login.
    - Fix failure when adding a new variable of a custom variable class
      to "postgresql.conf".
    - Throw an error if "pg_hba.conf" contains hostssl but SSL is
      disabled.  This was concluded to be more user-friendly than the previous
      behavior of silently ignoring such lines.
    - Fix failure when "DROP OWNED BY" attempts to remove default
      privileges on sequences.
    - Fix typo in pg_srand48 seed initialization.
      This led to failure to use all bits of the provided seed. This
      function is not used on most platforms (only those without
      srandom), and the potential security exposure from a
      less-random-than-expected seed seems minimal in any case.
    - Avoid integer overflow when the sum of LIMIT and OFFSET values
      exceeds 2^63.
    - Add overflow checks to int4 and int8 versions of generate_series()
    - Fix trailing-zero removal in to_char(). In a format with FM and no digit
      positions after the decimal point, zeroes to the left of the decimal
      point could be removed incorrectly.
    - Fix pg_size_pretty() to avoid overflow for inputs close to 2^63.
    - Weaken plpgsql's check for typmod matching in record values.
      An overly enthusiastic check could lead to discarding length
      modifiers that should have been kept.
    - In pg_upgrade, avoid dumping orphaned temporary tables.  This prevents
      situations wherein table OID assignments could get out of sync between old
      and new installations.
    - Fix pg_upgrade to preserve toast tables' relfrozenxids during an
      upgrade from 8.3. Failure to do this could lead to "pg_clog" files being
      removed too soon after the upgrade.
    - Fix psql's counting of script file line numbers during COPY from a
      different file.
    - Fix pg_restore's direct-to-database mode for
      standard_conforming_strings. pg_restore could emit incorrect commands
      when restoring directly to a database server from an archive file that
      had been made with standard_conforming_strings set to on.
    - Be more user-friendly about unsupported cases for parallel
      pg_restore. This change ensures that such cases are detected and
      reported before any restore actions have been taken.
    - Fix write-past-buffer-end and memory leak in libpq's LDAP service
      lookup code.
    - In libpq, avoid failures when using nonblocking I/O and an SSL
      connection.
    - Improve libpq's handling of failures during connection startup.
      In particular, the response to a server report of fork() failure
      during SSL connection startup is now saner.
    - Improve libpq's error reporting for SSL failures.
    - Fix PQsetvalue() to avoid possible crash when adding a new tuple to
      a PGresult originally obtained from a server query.
    - Make ecpglib write double values with 15 digits precision.
    - In ecpglib, be sure LC_NUMERIC setting is restored after an error.
    - Apply upstream fix for blowfish signed-character bug
      (CVE-2011-2483) (Tom Lane) (Closes: #636571)
      "contrib/pg_crypto"'s blowfish encryption code could give wrong
      results on platforms where char is signed (which is most), leading
      to encrypted passwords being weaker than they should be.
    - Fix memory leak in "contrib/seg".
    - Fix pgstatindex() to give consistent results for empty indexes.
    - Allow building with perl 5.14. (Closes: #628505)
  * Drop 03-cmsgcred-size.patch. Fixed upstream in a different way.

 -- Martin Pitt <mpitt@debian.org>  Sun, 25 Sep 2011 14:23:07 +0200

postgresql-9.0 (9.0.4-3) unstable; urgency=low

  * debian/control: Stop building the client-side libraries, they are built by
    postgresql-9.1 now. Add libpq-dev build dependency.
  * debian/rules: Drop check for uninstalled files, since it'd now break the
    build due to the uninstalled libraries.

 -- Martin Pitt <mpitt@debian.org>  Fri, 09 Sep 2011 09:09:47 +0200

postgresql-9.0 (9.0.4-2) unstable; urgency=low

  * debian/postgresql-9.0.postrm: Clean up pg_ctl.conf on purge.
  * Add 03-cmsgcred-size.patch: Fix size of struct cmsgcred to fix ident
    authentication on kFreeBSD 64 bit. Thanks to Petr Salinger for the
    patch! (Closes: #627596)
  * debian/control: Add explicit build dependency to jade. (Closes: #621492)
  * debian/control: Drop the versionless metapackages, they are built by -9.1
    now.

 -- Martin Pitt <mpitt@debian.org>  Thu, 25 Aug 2011 12:48:18 +0200

postgresql-9.0 (9.0.4-1) unstable; urgency=medium

  Priority medium due to data-loss pg_upgrade bug.

  * New upstream bug fix release:
    - If your installation was upgraded from a previous major release by
      running pg_upgrade, you should take action to prevent possible data loss
      due to a now-fixed bug in pg_upgrade. The recommended solution is to run
      "VACUUM FREEZE" on all TOAST tables.  More information is available at
      http://wiki.postgresql.org/wiki/20110408pg_upgrade_fix.
    - Fix pg_upgrade's handling of TOAST tables.
      This error poses a significant risk of data loss for installations
      that have been upgraded with pg_upgrade. This patch corrects the
      problem for future uses of pg_upgrade, but does not in itself cure
      the issue in installations that have been processed with a buggy
      version of pg_upgrade.
    - Suppress incorrect "PD_ALL_VISIBLE flag was incorrectly set"
      warning.
    - Use better SQLSTATE error codes for hot standby conflict cases.
    - Prevent intermittent hang in interactions of startup process with
      bgwriter process.  This affected recovery in non-hot-standby cases.
    - Disallow including a composite type in itself.
    - Avoid potential deadlock during catalog cache initialization.
    - Fix dangling-pointer problem in BEFORE ROW UPDATE trigger handling
      when there was a concurrent update to the target tuple.
    - Disallow "DROP TABLE" when there are pending deferred trigger
      events for the table.
      Formerly the "DROP" would go through, leading to "could not open
      relation with OID nnn" errors when the triggers were eventually
      fired.
    - Allow "replication" as a user name in "pg_hba.conf".
      "replication" is special in the database name column, but it was
      mistakenly also treated as special in the user name column.
    - Prevent crash triggered by constant-false WHERE conditions during
      GEQO optimization.
    - Improve planner's handling of semi-join and anti-join cases.
    - Fix handling of SELECT FOR UPDATE in a sub-SELECT.
      This bug typically led to "cannot extract system attribute from
      virtual tuple" errors.
    - Fix selectivity estimation for text search to account for NULLs.
    - Fix get_actual_variable_range() to support hypothetical indexes
      injected by an index adviser plugin.
    - Fix PL/Python memory leak involving array slices.
    - Allow libpq's SSL initialization to succeed when user's home
      directory is unavailable.
      If the SSL mode is such that a root certificate file is not
      required, there is no need to fail. This change restores the
      behavior to what it was in pre-9.0 releases.
    - Fix libpq to return a useful error message for errors detected in
      conninfo_array_parse.
    - Fix ecpg preprocessor's handling of float constants.
    - Fix parallel pg_restore to handle comments on POST_DATA items
      correctly.
    - Fix pg_restore to cope with long lines (over 1KB) in TOC files.
    - Put in more safeguards against crashing due to division-by-zero
      with overly enthusiastic compiler optimization. (Closes: #616180)
  * debian/control: Build debug package. (Closes: #551880)
  * debian/control, debian/rules: Drop usage of pycentral. We don't ship any
    Python extension/module, so we don't need a python helper at all.
    (Closes: #616949)

 -- Martin Pitt <mpitt@debian.org>  Wed, 20 Apr 2011 15:08:32 +0200

postgresql-9.0 (9.0.3-1) unstable; urgency=low

  * New upstream security/bug fix release:
    - Fix buffer overrun in "contrib/intarray"'s input function for the
      query_int type.
      This bug is a security risk since the function's return address
      could be overwritten. Thanks to Apple Inc's security team for
      reporting this issue and supplying the fix. (CVE-2010-4015)
    - Before exiting walreceiver, ensure all the received WAL is fsync'd
      to disk. Otherwise the standby server could replay some un-synced WAL,
      conceivably leading to data corruption if the system crashes just
      at that point.
    - Avoid excess fsync activity in walreceiver.
    - Make "ALTER TABLE" revalidate uniqueness and exclusion constraints
      when needed. This was broken in 9.0 by a change that was intended to
      suppress revalidation during "VACUUM FULL" and "CLUSTER", but
      unintentionally affected "ALTER TABLE" as well.
    - Fix EvalPlanQual for "UPDATE" of an inheritance tree in which the
      tables are not all alike.
      Any variation in the table row types (including dropped columns
      present in only some child tables) would confuse the EvalPlanQual
      code, leading to misbehavior or even crashes. Since EvalPlanQual is
      only executed during concurrent updates to the same row, the
      problem was only seen intermittently.
    - Avoid failures when "EXPLAIN" tries to display a simple-form CASE
      expression.
      If the CASE's test expression was a constant, the planner could
      simplify the CASE into a form that confused the expression-display
      code, resulting in "unexpected CASE WHEN clause" errors.
    - Fix assignment to an array slice that is before the existing range
      of subscripts.
      If there was a gap between the newly added subscripts and the first
      pre-existing subscript, the code miscalculated how many entries
      needed to be copied from the old array's null bitmap, potentially
      leading to data corruption or crash.
    - Avoid unexpected conversion overflow in planner for very distant
      date values.
      The date type supports a wider range of dates than can be
      represented by the timestamp types, but the planner assumed it
      could always convert a date to timestamp with impunity.
    - Fix PL/Python crash when an array contains null entries.
    - Remove ecpg's fixed length limit for constants defining an array
      dimension.
    - Fix erroneous parsing of tsquery values containing ... &
      !(subexpression) | ... .
      Queries containing this combination of operators were not executed
      correctly. The same error existed in "contrib/intarray"'s query_int
      type and "contrib/ltree"'s ltxtquery type.
    - Fix bug in "contrib/seg"'s GiST picksplit algorithm.
      This could result in considerable inefficiency, though not actually
      incorrect answers, in a GiST index on a seg column. If you have
      such an index, consider "REINDEX"ing it after installing this
      update. (This is identical to the bug that was fixed in
      "contrib/cube" in the previous update.)

 -- Martin Pitt <mpitt@debian.org>  Tue, 01 Feb 2011 17:01:48 +0100

postgresql-9.0 (9.0.2-1) unstable; urgency=low

  * New upstream bug fix release:
    - Force the default wal_sync_method to be fdatasync on Linux.
      The default on Linux has actually been fdatasync for many years,
      but recent kernel changes caused PostgreSQL to choose open_datasync
      instead. This choice did not result in any performance improvement,
      and caused outright failures on certain filesystems, notably ext4
      with the data=journal mount option.
    - Fix "too many KnownAssignedXids" error during Hot Standby replay.
    - Fix race condition in lock acquisition during Hot Standby.
    - Avoid unnecessary conflicts during Hot Standby.
      This fixes some cases where replay was considered to conflict with
      standby queries (causing delay of replay or possibly cancellation
      of the queries), but there was no real conflict.
    - Fix assorted bugs in WAL replay logic for GIN indexes.
      This could result in "bad buffer id: 0" failures or corruption of
      index contents during replication.
    - Fix recovery from base backup when the starting checkpoint WAL
      record is not in the same WAL segment as its redo point.
    - Fix corner-case bug when streaming replication is enabled
      immediately after creating the master database cluster.
    - Fix persistent slowdown of autovacuum workers when multiple workers
      remain active for a long time.
      The effective vacuum_cost_limit for an autovacuum worker could drop
      to nearly zero if it processed enough tables, causing it to run
      extremely slowly.
    - Fix long-term memory leak in autovacuum launcher.
    - Avoid failure when trying to report an impending transaction
      wraparound condition from outside a transaction.
      This oversight prevented recovery after transaction wraparound got
      too close, because database startup processing would fail.
    - Add support for detecting register-stack overrun on IA64.
      The IA64 architecture has two hardware stacks. Full prevention of
      stack-overrun failures requires checking both.
    - Add a check for stack overflow in copyObject().
      Certain code paths could crash due to stack overflow given a
      sufficiently complex query.
    - Fix detection of page splits in temporary GiST indexes.
      It is possible to have a "concurrent" page split in a temporary
      index, if for example there is an open cursor scanning the index
      when an insertion is done. GiST failed to detect this case and
      hence could deliver wrong results when execution of the cursor
      continued.
    - Fix error checking during early connection processing.
      The check for too many child processes was skipped in some cases,
      possibly leading to postmaster crash when attempting to add the new
      child process to fixed-size arrays.
    - Improve efficiency of window functions. Certain cases where a large
      number of tuples needed to be read in advance, but work_mem was large
      enough to allow them all to be held in memory, were unexpectedly slow.
      percent_rank(), cume_dist() and ntile() in particular were subject to
      this problem.
    - Avoid memory leakage while "ANALYZE"'ing complex index expressions.
    - Ensure an index that uses a whole-row Var still depends on its
      table.
      An index declared like create index i on t (foo(t.-)) would not
      automatically get dropped when its table was dropped.
    - Add missing support in "DROP OWNED BY" for removing foreign data
      wrapper/server privileges belonging to a user.
    - Do not "inline" a SQL function with multiple OUT parameters.
      This avoids a possible crash due to loss of information about the
      expected result rowtype.
    - Fix crash when inline-ing a set-returning function whose argument
      list contains a reference to an inline-able user function.
    - Behave correctly if ORDER BY, LIMIT, FOR UPDATE, or WITH is
      attached to the VALUES part of INSERT ... VALUES.
    - Make the OFF keyword unreserved.
      This prevents problems with using off as a variable name in
      PL/pgSQL. That worked before 9.0, but was now broken because
      PL/pgSQL now treats all core reserved words as reserved.
    - Fix constant-folding of COALESCE() expressions.
      The planner would sometimes attempt to evaluate sub-expressions
      that in fact could never be reached, possibly leading to unexpected
      errors.
    - Fix "could not find pathkey item to sort" planner failure with
      comparison of whole-row Vars.
    - Fix postmaster crash when connection acceptance (accept() or one of
      the calls made immediately after it) fails, and the postmaster was
      compiled with GSSAPI support.
    - Retry after receiving an invalid response packet from a RADIUS
      authentication server.
      This fixes a low-risk potential denial of service condition.
    - Fix missed unlink of temporary files when log_temp_files is active.
      If an error occurred while attempting to emit the log message, the
      unlink was not done, resulting in accumulation of temp files.
    - Add print functionality for InhRelation nodes.
      This avoids a failure when debug_print_parse is enabled and certain
      types of query are executed.
    - Fix incorrect calculation of distance from a point to a horizontal
      line segment.
      This bug affected several different geometric distance-measurement
      operators.
    - Fix incorrect calculation of transaction status in ecpg.
    - Fix errors in psql's Unicode-escape support.
    - Speed up parallel pg_restore when the archive contains many large
      objects (blobs).
    - Fix PL/pgSQL's handling of "simple" expressions to not fail in
      recursion or error-recovery cases.
    - Fix PL/pgSQL's error reporting for no-such-column cases.
      As of 9.0, it would sometimes report "missing FROM-clause entry for
      table foo" when "record foo has no field bar" would be more
      appropriate.
    - Fix PL/Python to honor typmod (i.e., length or precision
      restrictions) when assigning to tuple fields.
      This fixes a regression from 8.4.
    - Fix PL/Python's handling of set-returning functions.
      Attempts to call SPI functions within the iterator generating a set
      result would fail.
    - Fix bug in "contrib/cube"'s GiST picksplit algorithm.
      This could result in considerable inefficiency, though not actually
      incorrect answers, in a GiST index on a cube column. If you have
      such an index, consider "REINDEX"ing it after installing this
      update.
    - Don't emit "identifier will be truncated" notices in
      "contrib/dblink" except when creating new connections.
    - Fix potential coredump on missing public key in "contrib/pgcrypto".
    - Fix buffer overrun in "contrib/pg_upgrade".
    - Fix memory leak in "contrib/xml2"'s XPath query functions.

 -- Martin Pitt <mpitt@debian.org>  Sat, 18 Dec 2010 22:28:42 +0100

postgresql-9.0 (9.0.1-2) unstable; urgency=low

  * debian/control: Build against libedit instead of libreadline. We can't
    simultaneously link against readline (GPL) and libssl (incompatible with
    GPL). (Closes: #603599)

 -- Martin Pitt <mpitt@debian.org>  Wed, 17 Nov 2010 15:07:58 +0100

postgresql-9.0 (9.0.1-1) unstable; urgency=low

  * New upstream security/bug fix release:
    - Use a separate interpreter for each calling SQL userid in PL/Perl
      and PL/Tcl.
      This change prevents security problems that can be caused by
      subverting Perl or Tcl code that will be executed later in the same
      session under another SQL user identity (for example, within a
      SECURITY DEFINER function). Most scripting languages offer numerous
      ways that that might be done, such as redefining standard functions
      or operators called by the target function. Without this change,
      any SQL user with Perl or Tcl language usage rights can do
      essentially anything with the SQL privileges of the target
      function's owner.
      The cost of this change is that intentional communication among
      Perl and Tcl functions becomes more difficult. To provide an escape
      hatch, PL/PerlU and PL/TclU functions continue to use only one
      interpreter per session. This is not considered a security issue
      since all such functions execute at the trust level of a database
      superuser already.
      It is likely that third-party procedural languages that claim to
      offer trusted execution have similar security issues. We advise
      contacting the authors of any PL you are depending on for
      security-critical purposes.
      Our thanks to Tim Bunce for pointing out this issue
      (CVE-2010-3433).
    - Improve pg_get_expr() security fix so that the function can still
      be used on the output of a sub-select.
    - Fix incorrect placement of placeholder evaluation.
      This bug could result in query outputs being non-null when they
      should be null, in cases where the inner side of an outer join is a
      sub-select with non-strict expressions in its output list.
    - Fix join removal's handling of placeholder expressions.
    - Fix possible duplicate scans of UNION ALL member relations.
    - Prevent infinite loop in ProcessIncomingNotify() after unlistening.
    - Prevent show_session_authorization() from crashing within
      autovacuum processes.
    - Re-allow input of Julian dates prior to 0001-01-01 AD.
      Input such as 'J100000'::date worked before 8.4, but was
      unintentionally broken by added error-checking.
    - Make psql recognize "DISCARD ALL" as a command that should not be
      encased in a transaction block in autocommit-off mode.
    - Update build infrastructure and documentation to reflect the source
      code repository's move from CVS to Git.

 -- Martin Pitt <mpitt@debian.org>  Tue, 05 Oct 2010 20:42:30 +0200

postgresql-9.0 (9.0.0-3) unstable; urgency=low

  * debian/postgresql-9.0.preinst: Add missing debhelper token.
  * debian/rules: debian/rules: Set DPKG_GENSYMBOLS_CHECK_LEVEL to 4 to point
    out outdated .symbols files more strongly.
  * Add symbols files for libecpg-compat3, libecpg6, and libpgtypes3.

 -- Martin Pitt <mpitt@debian.org>  Tue, 21 Sep 2010 01:23:54 +0200

postgresql-9.0 (9.0.0-2) unstable; urgency=low

  * debian/rules: Reenable building with -O1 on sparc and alpha, floating
    point with -O2 is still broken there.
  * Drop debian/libpq5.shlibs, replace it with a proper debian/libpq5.symbols.
    This keeps the reverse dependencies of libpq5 to >= 8.4, unless they use
    one of the four new functions.

 -- Martin Pitt <mpitt@debian.org>  Mon, 20 Sep 2010 19:46:33 +0200

postgresql-9.0 (9.0.0-1) unstable; urgency=low

  * Final 9.0 release, upload to unstable (will not go into Squeeze, though).
  * debian/postgresql-9.0.preinst: Add missing debhelper token.
  * debian/control: Bump Standards-Version to 3.9.1; no changes necessary.
  * debian/control: Build the versionless metapackages now and point them to
    9.0.
  * debian/control: Fix Vcs-* to point to 9.0 branch.
  * debian/rules: Drop special-case building with -O1 on sparc and alpha,
    let's see how the current compiler does.

 -- Martin Pitt <mpitt@debian.org>  Fri, 17 Sep 2010 11:41:29 +0200

postgresql-9.0 (9.0~rc1-1) experimental; urgency=low

  * First 9.0 release candidate.

 -- Martin Pitt <mpitt@debian.org>  Wed, 01 Sep 2010 11:50:54 +0200

postgresql-9.0 (9.0~beta4-1) experimental; urgency=low

  * New upstream beta release.

 -- Martin Pitt <mpitt@debian.org>  Sun, 01 Aug 2010 21:19:01 +0200

postgresql-9.0 (9.0~beta3-2) experimental; urgency=low

  * Migrate to a common init script for all server versions, to avoid
    providing the "postgresql" service in multiple packages (which causes
    insserv to complain bitterly):
    - Drop debian/postgresql-9.0.init.
    - debian/control: Bump dependency to postgresql-common to ensure we have a
      common /etc/init.d/postgresql init script.
    - debian/postgresql-9.0.preinst: Remove/rename our init script on upgrade.	
    - debian/postgresql-9.0.prerm: Call stop_version on upgrade/removal.
    - debian/rules: Drop dh_installinit arguments.
    - (Closes: #589523)

 -- Martin Pitt <mpitt@debian.org>  Mon, 19 Jul 2010 23:34:13 +0200

postgresql-9.0 (9.0~beta3-1) experimental; urgency=low

  * New upstream beta release.
  * debian/postgresql-contrib-9.0.install: Add the new pg_archivecleanup.

 -- Martin Pitt <mpitt@debian.org>  Tue, 13 Jul 2010 10:09:02 +0200

postgresql-9.0 (9.0~beta2-1) experimental; urgency=low

  * New upstream beta release.
  * debian/postgresql-9.0.install: Install pg_upgrade.
  * debian/control: Set back maintainer to me, but keep Peter Eisentraut as
    Uploader.

 -- Martin Pitt <mpitt@debian.org>  Sun, 06 Jun 2010 19:18:03 +0200

postgresql-9.0 (9.0~beta1-1) experimental; urgency=low

  [ Peter Eisentraut ]
  * Create 9.0 package based on 8.4 packaging trunk. Don't build versionless
    metapackages for 9.0 yet.
    - Adjusted 11-pg_regress-socketpath.patch
    - Obsoletes 03-sh-architecture.patch
  * Dropped obsolete documentation build.
  * debian/rules: Use make world/install-world targets, obsoletes
    01-build-contrib.patch.
  * debian/watch: Adjusted for alpha releases.

  [ Martin Pitt ]
  * Update to upstream beta 1 release.
  * 07-relax-sslkey-permscheck.patch: Add parentheses around || .. &&
    construct to avoid a compiler warning (which turns into an error when
    building with -Werror). Also add a DEP3 compatible header.
  * 14-pg_config-paths.patch: Drop now unused "ret" variable (fix FTBFS with
    -Werror). Add a DEP3 compatible header.
  * debian/control: Bump p-common dependency to >= 107~ to ensure support for
    9.0.
  * debian/disable-root-check.patch: Refresh to apply cleanly.
  * Convert source package to "3.0 (quilt)" format.
  * Refresh patches to apply without fuzz.
  * debian/control: Bump Standards-Version to 3.8.4 (no changes necessary).
  * debian/patches/: Add DEP-3 compatible patch descriptions.
  * Merge 08-pkglibdir.patch, 09-server-includedir.patch, and
    14-pg_config-paths.patch into 50-per-version-dirs.patch, since they really
    belong together.
  * Merge 06-libpq-defaultsocketdir.patch and 11-pg_regress-socketpath.patch
    into 51-default-sockets-in-var.patch, they really belong together.
  * Re-enumerate 10-tutorial-README.patch and
    13-pg_service.conf_directory_doc.patch to 5x-*, since they are Debian
    specific.
  * Merge 02-pager.patch and 12-psql-sensible-editor.patch into
    54-debian-alternatives-for-external-tools.patch.
  * Re-enumerate remaining patches.

 -- Martin Pitt <mpitt@debian.org>  Mon, 03 May 2010 07:45:23 +0200
